/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.common.action;

import java.util.Date;
import java.util.List;

import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.payroll.base.PayrollAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.bonus.action.BonusSlipOutputAction;
import jp.mosp.payroll.bonus.dao.PhBounsDao;
import jp.mosp.payroll.bonus.dto.PhBounsDto;
import jp.mosp.payroll.common.vo.ReferSlipVo;
import jp.mosp.payroll.dao.PhPaymentDao;
import jp.mosp.payroll.dto.PhPaymentDto;
import jp.mosp.payroll.payment.action.PaySlipOutputAction;

/**
 * 給賞与明細参照画面における処理を行う。<br><br>
 * 以下のコマンドを扱う。
 * <ul><li>
 * {@link #CMD_SHOW}
 * </li><li>
 * {@link #CMD_SEARCH}
 * </li><li>
 * {@link #CMD_SORT}
 * </li><li>
 * {@link #CMD_PAGE}
 * </li></ul>
 */
public class ReferSlipAction extends PayrollAction {
	
	/**
	 * 画面表示コマンド。<br><br>
	 * システム日付の年、給与で、検索を行う。<br>
	 */
	public static final String	CMD_SHOW	= "P8500";
	
	/**
	 * 検索コマンド。<br><br>
	 * 指定された条件で給賞与データの検索を行い、一覧表示する。<br>
	 */
	public static final String	CMD_SEARCH	= "P8501";
	
	/**
	 * ソートコマンド。<br><br>
	 * 指定された条件で給賞与データの並べ替えを行い、一覧表示する。<br>
	 */
	public static final String	CMD_SORT	= "P8503";
	
	/**
	 * ページコマンド。<br><br>
	 * 指定された条件で給賞与データのページ繰りを行い、一覧表示する。<br>
	 */
	public static final String	CMD_PAGE	= "P8504";
	

	/**
	 * Actionの初期化を行う。<br><br>
	 * 以下の処理を行う。
	 * <ul><li>
	 * {@link PayrollAction#PayrollAction()}
	 * </li></ul>
	 */
	public ReferSlipAction() {
		super();
	}
	
	/* (non-Javadoc)
	 * @see jp.mosp.common.common.BaseAction#getSpecificVo()
	 */
	@Override
	protected BaseVo getSpecificVo() {
		return new ReferSlipVo();
	}
	
	/**
	 * アクション。<br>
	 * 詳細は、クラス説明を参照。<br>
	 */
	public void action() throws Exception {
		// VO取得及び設定
		prepareVo();
		if (cmd.equals(CMD_SHOW)) {
			// 画面表示
			show();
		} else if (cmd.equals(CMD_SEARCH)) {
			// 検索処理
			search();
		} else if (cmd.equals(CMD_SORT)) {
			// ソート処理
			sort();
		} else if (cmd.equals(CMD_PAGE)) {
			// ページ処理
			page();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	/**
	 * 画面表示処理を行う。<br><br>
	 * @throws Exception 例外処理が発生した場合
	 */
	@Override
	public void show() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// 情報取得
		getInfo(user.getUserId());
		// 社員コード設定
		vo.setHidKCode(part().human().getBasisInfo(user.getUserId()).getKCode());
		// システム日付取得
		Date sysDate = new Date();
		// プルダウンアイテム設定
		vo.setPitYear(getYearArray(PayrollConst.DEFAULT_CURRENT_YEAR, MospUtility.getYear(sysDate) + 1));
		// VOフィールド設定
		vo.setPltYear(MospUtility.getYear(sysDate));
		vo.setPltType(PayrollConst.CALC_PAYMENT);
		// リスト取得
		getList();
	}
	
	/**
	 * 検索処理を行う。
	 * @throws Exception 例外処理が発生した場合
	 */
	@Override
	public void search() throws Exception {
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// パラメータ取得
		vo.setParams(request);
		// リスト取得
		getList();
	}
	
	/**
	 * ソート処理を行う。
	 * @throws Exception 例外処理が発生した場合
	 */
	private void sort() throws Exception {
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// ソート情報設定
		vo.setSortKey(key1);
		vo.setSelectIndex(1);
		// リスト取得
		getList();
	}
	
	/**
	 * ページ処理を行う。
	 * @throws Exception 例外処理が発生した場合
	 */
	private void page() throws Exception {
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// ページ情報設定
		vo.setSelectIndex(Integer.parseInt(key1));
		// リスト取得
		getList();
	}
	
	/**
	 * リストを取得する。
	 * @throws Exception 例外処理が発生した場合
	 */
	private void getList() throws Exception {
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// 給賞与区分確認
		if (vo.getPltType() == PayrollConst.CALC_BONUS) {
			// 明細出力コマンド設定
			vo.setHidCmd(BonusSlipOutputAction.CMD_REPORT);
			// 賞与明細取得
			vo.setFields(getBonusList());
		} else {
			// 明細出力コマンド設定
			vo.setHidCmd(PaySlipOutputAction.CMD_REPORT);
			// 給与明細取得
			vo.setFields(getPaymentList());
		}
		// 対象が無かった場合のメッセージ設定
		if (vo.getCount() == 0) {
			vo.addErrMessage(MospUtility.getMessage(msg, MospConst.MSG_NO_DATA, ""));
		}
	}
	
	/**
	 * 給与明細リストを取得する。
	 * @return 給与明細リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	private List<PhPaymentDto> getPaymentList() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// DAO準備
		PhPaymentDao dao = new PhPaymentDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getHidKCode(), getFirstDateOfTheYear(vo.getPltYear()), getLastDateOfTheYear(vo
			.getPltYear())));
		// 検索
		List<PhPaymentDto> list = dao.find(vo.getHidKCode(), getFirstDateOfTheYear(vo.getPltYear()),
				getLastDateOfTheYear(vo.getPltYear()), getSortKey(), vo.getIsAscending(), vo.getDataPerPage(), vo
					.getOffset());
		// 計算中確認
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_PAYMENT);
		if (current == null) {
			return list;
		}
		// 計算中情報除去
		for (int i = 0; i < list.size(); i++) {
			PhPaymentDto dto = list.get(i);
			if (current.compareTo(dto.getCalcMonth()) == 0) {
				list.remove(i);
				vo.setCountAllData(vo.getCountAllData() - 1);
				break;
			}
		}
		return list;
	}
	
	/**
	 * 賞与明細リストを取得する。
	 * @return 賞与明細リスト
	 * @throws Exception 例外処理が発生した場合
	 */
	private List<PhBounsDto> getBonusList() throws Exception {
		// コネクション取得
		getConnection();
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// DAO準備
		PhBounsDao dao = new PhBounsDao(cfg, cmd, aspUser, user, conn);
		// 件数取得
		vo.setCountAllData(dao.count(vo.getHidKCode(), getFirstDateOfTheYear(vo.getPltYear()), getLastDateOfTheYear(vo
			.getPltYear())));
		// 検索
		List<PhBounsDto> list = dao.find(vo.getHidKCode(), getFirstDateOfTheYear(vo.getPltYear()),
				getLastDateOfTheYear(vo.getPltYear()), getSortKey(), vo.getIsAscending(), vo.getDataPerPage(), vo
					.getOffset());
		// 計算中確認
		Date current = getCurrent(PayrollConst.OFFICE_ALL, PayrollConst.CALC_BONUS);
		if (current == null) {
			return list;
		}
		// 計算中情報除去
		for (int i = 0; i < list.size(); i++) {
			PhBounsDto dto = list.get(i);
			if (current.compareTo(dto.getCalcMonth()) == 0) {
				list.remove(i);
				vo.setCountAllData(vo.getCountAllData() - 1);
				break;
			}
		}
		return list;
	}
	
	/**
	 * ソートキーを取得する。<br>
	 * @return ソートキー
	 */
	private String getSortKey() {
		// VO取得
		ReferSlipVo vo = (ReferSlipVo)getVo();
		// 選択キー取得
		String selectKey = vo.getSelectKey();
		// ソートキー取得
		String sortKey = PhPaymentDao.COL_PAY_DATE;
		if (selectKey == null) {
			// 処理無し
		} else if (selectKey.equals("2")) {
			sortKey = PhPaymentDao.COL_ALLOWANCE_TOTAL;
		} else if (selectKey.equals("3")) {
			sortKey = PhPaymentDao.COL_DEDUCTION_TOTAL;
		} else if (selectKey.equals("4")) {
			sortKey = PhPaymentDao.COL_PAYMENT_TOTAL;
		}
		return sortKey;
	}
	
}
